package com.focasoftware.deboinventariov20.DB.DataBase

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import com.focasoftware.deboinventariov20.DB.Constans.Constans
import com.focasoftware.deboinventariov20.DB.DAO.*
import com.focasoftware.deboinventariov20.Model.*


@Database(entities = [InvBodySec::class, InvHeadSec::class, Articles::class, InvHead::class, InvBody::class, ServeInv::class], version = 1, exportSchema = false)
abstract class AppDb : RoomDatabase() {
    abstract fun ArticulosDAO(): ArticulosDAO?
    abstract fun InvHeadDAO(): InvHeadDAO?
    abstract fun InvBodyDAO(): InvBodyDAO?
    abstract fun ServeInvDao(): ServeInvDao?
    abstract fun InvHeadSecDAO(): InvHeadSecDAO?
    abstract fun InvBodySecDAO(): InvBodySecDAO?

    companion object {
        private var INSTANCE: AppDb? = null
        fun getAppDb(context: Context): AppDb? {
            if (INSTANCE == null) {
                INSTANCE = Room.databaseBuilder(context.applicationContext, AppDb::class.java, Constans.DB_NAME)
                    .allowMainThreadQueries()
                    .build()
            }
            return INSTANCE
        }

        fun destroyInstance() {
            INSTANCE = null
        }
    }
}