package com.focasoftware.deboinventariov20.Model

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_ART
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_INV_B
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_INV_H
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_INV_SEC_B
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_INV_SEC_H
import com.focasoftware.deboinventariov20.DB.Constans.Constans.Companion.TABLA_SERV_INV
import com.google.gson.annotations.SerializedName
import java.io.Serializable

data class Productos(
    @SerializedName("CODSEC") var sector: String?,
    @SerializedName("CODART") var codigo: String?,
    @SerializedName("DETART") var descripcion: String?,
    @SerializedName("CODBAR") var codBar: String?,
    @SerializedName("COO") var codOrigen: String?,
    @SerializedName("PREVEN") var precio: String?,
    @SerializedName("COSTO") var costo: String?,
    @SerializedName("EXIVTA") var exiVenta: String?,
    @SerializedName("EXIDEP") var exiDeposito: String?,
    @SerializedName("DVE") var de: String?,
    @SerializedName("UNIVEN") var balanza: Int?,
    @SerializedName("DEPSN") var depSn: Boolean?,
    @SerializedName("FOTO") var imagen: String?
)

data class Time(
    @SerializedName("DIA") var dia: String?,
    @SerializedName("MES") var mes: String?,
    @SerializedName("ANO") var ano: String?,
    @SerializedName("HORA") var hora: String?,
    @SerializedName("MIN") var minutos: String?,
    @SerializedName("SEG") var segundos: String?
)

data class InvHeadSecR(
    @SerializedName("INV_NUM") var invNum: Int,
    @SerializedName("DET") var detalle: String,
    @SerializedName("FET") var fechaInicio: String,
    @SerializedName("DEP") var depsn: Int
)

data class InvBodySecR(
    @SerializedName("INV") var INV: String,
    @SerializedName("SEC") var SEC: String?,
    @SerializedName("ART") var ART: String?,
    @SerializedName("DET") var DET: String?,
    @SerializedName("PRE") var PRE: String?,
    @SerializedName("COS") var COS: String?,
    @SerializedName("DVE") var DVE: String?,
    @SerializedName("EXIVTA") var EXIVTA: String?,
    @SerializedName("EXIDEP") var EXIDEP: String?,
    @SerializedName("CODBAR") var CODBAR: String?,
    @SerializedName("COO") var COO: String?,
    @SerializedName("DEPSN") var DEPSN: String?,
    @SerializedName("UNIVEN") var uniVta: String?
)

data class ItomInvD(
    var Sector: String?,
    var Codigo: String?,
    var Descripcion: String?,
    var CantTomada: String?,
    var FechaInicioArt: String?,
    var FechaFinArt: String?
)

data class InvToSend(
    var FechaInicio: String?,
    var FechaFinal: String?,
    var Lugar: Int?,
    var Sector: String?,
    var Codigo: String?,
    var Descripcion: String?,
    var CantTomada: String?,
    var FechaInicioArt: String?,
    var FechaFinArt: String?
)

data class ItomInvC(
    var FechaInicio: String?,
    var FechaFinal: String?,
    var Lugar: Int?,
)

data class InvSecHeadToSend(
    var ID: String?,
    var EST: String?,
    var FEC: String?
)

data class InvSecBodyToSend(
    var INV: String?,
    var SEC: String?,
    var ART: String?,
    var CON: String?,
    var FECTOM: String?,
    var FECTOMFIN: String?
)

data class NumInvSec(var inv_num: String?)

@Entity(tableName = TABLA_ART)
data class Articles(
    @ColumnInfo(name = "CODSEC") var sector: String?,
    @ColumnInfo(name = "CODART") var codigo: String?,
    @ColumnInfo(name = "DETART") var descripcion: String?,
    @ColumnInfo(name = "CODBAR") var codBar: String?,
    @ColumnInfo(name = "COO") var codOrigen: String?,
    @ColumnInfo(name = "PREVEN") var precio: String?,
    @ColumnInfo(name = "COSTO") var costo: String?,
    @ColumnInfo(name = "EXIVTA") var exiVenta: String?,
    @ColumnInfo(name = "EXIDEP") var exiDeposito: String?,
    @ColumnInfo(name = "DVE") var de: String?,
    @ColumnInfo(name = "UNIVEN") var balanza: Int?,
    @ColumnInfo(name = "DEPSN") var depSn: Boolean?,
    @ColumnInfo(name = "FOTO") var imagen: String?
) : Serializable {
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "id")
    var id: Long = 0
}


@Entity(tableName = TABLA_INV_H)
data class InvHead(
    @PrimaryKey(autoGenerate = true) @ColumnInfo(name = "INV_NUM") var invNum: Int,
    @ColumnInfo(name = "INV_DESC") var descripcion: String?,
    @ColumnInfo(name = "ESTADO") var estado: Int?,
    @ColumnInfo(name = "INV_FEI") var fechaInicio: String?,
    @ColumnInfo(name = "INV_FEF") var fechaFinal: String?,
//    productos contados en el inventario
    @ColumnInfo(name = "INV_PRODCONT") var prodContados: Long?,
    @ColumnInfo(name = "INV_LUG") var lugar: Boolean?,
//    Solo se ajustan los productos incluidos en el conteo=0
//    Ajusta productos no incluidos en el conteo con stock en cero=1
    @ColumnInfo(name = "PRO_NO_CONTA") var stDesc: Int?,
//    Mostror stock en el sistema al momento de la descarga del maestro.
    @ColumnInfo(name = "MOSTRAR_STOCK") var proNoCont: Int?
)


@Entity(tableName = TABLA_INV_B)
data class InvBody(
    @ColumnInfo(name = "INV_NUM") var invNum: Int,
    @ColumnInfo(name = "SEC") var sector: String?,
    @ColumnInfo(name = "COD") var codigo: String?,
    @ColumnInfo(name = "DES") var descripcion: String?,
    @ColumnInfo(name = "CANT") var cantTomada: String?,
    @ColumnInfo(name = "CB") var codBar: String?,
    @ColumnInfo(name = "CBC") var codOrigen: String?,
    @ColumnInfo(name = "PRE_VTA") var precio: String?,
    @ColumnInfo(name = "PRE_COS") var costo: String?,
    @ColumnInfo(name = "BAL") var balanza: Int?,
    @ColumnInfo(name = "DSN") var depSn: Boolean?,
    @ColumnInfo(name = "INV_FEI") var fechaInicio: String?,
    @ColumnInfo(name = "INV_FEF") var fechaFinal: String?
) : Serializable {
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "id")
    var id: Long = 0
}

@Entity(tableName = TABLA_SERV_INV)
data class ServeInv(
    @ColumnInfo(name = "SER_DESC") var descripcion: String?,
    @ColumnInfo(name = "SER_DIR") var direccion: String?,
    @ColumnInfo(name = "SER_PUERTO_SUBIDA") var puertoSubida: String?,
    @ColumnInfo(name = "SER_PUERTO_BAJADA") var puertoBajada: String?,
    @ColumnInfo(name = "SER_PRE") var predeterminado: Int?
) :
    Serializable {
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "SER_NUM")
    var servNum: Int = 0
}

@Entity(tableName = TABLA_INV_SEC_H)
data class InvHeadSec(
    @PrimaryKey() @ColumnInfo(name = "INV_NUM") var invNum: Int,
    @ColumnInfo(name = "DET") var detalle: String?,
    @ColumnInfo(name = "FET") var fechaInicio: String?,
    @ColumnInfo(name = "DEP") var depsn: Boolean?,
    @ColumnInfo(name = "EST") var estado: String?,
    @ColumnInfo(name = "FEC") var fechaFinal: String?,
    @ColumnInfo(name = "CONT") var prodContados: Int?
)


@Entity(tableName = TABLA_INV_SEC_B)
data class InvBodySec(
    @ColumnInfo(name = "INV") var invNum: Int,
    @ColumnInfo(name = "SEC") var sector: String?,
    @ColumnInfo(name = "ART") var codigo: String?,
    @ColumnInfo(name = "DET") var descripcion: String?,
    @ColumnInfo(name = "PRE") var precio: String?,
    @ColumnInfo(name = "UNIVTA") var uniVenta: String?,
    @ColumnInfo(name = "COS") var costo: String?,
    @ColumnInfo(name = "CON") var contado: String?,
    @ColumnInfo(name = "DSN") var depSn: Boolean?,
    @ColumnInfo(name = "EXIVTA") var EXIVTA: String?,
    @ColumnInfo(name = "EXIDEP") var EXIDEP: String?,
    @ColumnInfo(name = "CODBAR") var CODBAR: String?,
    @ColumnInfo(name = "FECTOM") var fechaTomado: String?,
    @ColumnInfo(name = "FECTOMFIN") var fechaFinal: String?
) :
    Serializable {
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "ID")
    var id: Int = 0
}

