package com.focasoftware.deboinventariov20.UI.actualizacionMaestros

import android.os.Bundle
import android.os.SystemClock
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.fragment.app.Fragment
import androidx.navigation.NavController
import androidx.navigation.Navigation
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.*
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.MainActivity
import com.focasoftware.deboinventariov20.UI.Utils.NoServerConf
import com.focasoftware.deboinventariov20.UI.Utils.ServerNoConf
import com.focasoftware.deboinventariov20.UI.Utils.fetchServerPreOne
import kotlinx.android.synthetic.main.fragment_actua_maestros.*
import kotlinx.coroutines.*
import kotlinx.coroutines.Dispatchers.IO
import kotlinx.coroutines.Dispatchers.Main
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.net.SocketTimeoutException


private var serverPre: ServeInv? = null
private lateinit var navController: NavController
class ActuaMaestrosFragment : Fragment() {
    private val job: Job = Job()
    private val fragmentScopeAM = CoroutineScope(IO + job)
    private lateinit var countriesList:TextView
    private lateinit var loading_view:ProgressBar

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }

    override fun onDestroy() {
        super.onDestroy()
        fragmentScopeAM.cancel()
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val v = inflater.inflate(R.layout.fragment_actua_maestros, container, false)
        val bConfirmarAct = v.findViewById<Button>(R.id.btnConfirmarAct)
        val obPorWifi = v.findViewById<RadioButton>(R.id.obPorWifi)
        val obImpInventarios = v.findViewById<RadioButton>(R.id.obImpInventarios)
        countriesList = v.findViewById<TextView>(R.id.countriesList)
        loading_view= v.findViewById<ProgressBar>(R.id.loading_view)
        obPorWifi.setOnClickListener {
            bConfirmarAct.text = ("Confirmar Importación")
        }
        obImpInventarios.setOnClickListener {
            bConfirmarAct.text = ("Buscar Inventarios sectorizados")
        }

        bConfirmarAct.setOnClickListener {
            if (obPorWifi.isChecked) {
                loading_view.visibility = View.VISIBLE
                countriesList.text = ("Obteniendo artículos del servidor, aguarde por favor.")
                obtenerArticulos()
            }
            if (obImpInventarios.isChecked) {
                navController = Navigation.findNavController(v)
                navController.navigate(R.id.action_actuaMaestrosFragment_to_invSecImpFragment)
            }
        }
        return v
    }

    private fun obtenerArticulos() {
        fragmentScopeAM.launch(Main) {
            try {
                serverPre = fetchServerPreOne((activity as MainActivity))

            } catch (e: RuntimeException) {
                Toast.makeText(context, "Error ${e.message}", Toast.LENGTH_LONG).show()
            }
            if (serverPre != null) {
                if (serverPre!!.direccion.isNullOrEmpty()) {
                    val modalDialog = NoServerConf()
                    if (activity != null) {
                        modalDialog.show((activity as MainActivity).supportFragmentManager, "confirmDialog")
                    }
                } else {
                    BASE_URL = serverPre!!.direccion.toString() + ":" + serverPre!!.puertoBajada.toString() + "/"
                }
            } else {
                if (activity != null) {
                    val modalDialog = ServerNoConf()
                    modalDialog.show((activity as MainActivity).supportFragmentManager, "confirmDialog")
                }
            }


        try {
            val call: Call<List<Productos?>?>? = WebService.instance
                ?.createService(WebServiceApi::class.java)
                ?.getProductos()
            var index: Long = 1
            call!!.enqueue(object : Callback<List<Productos?>?> {
                override fun onResponse(call: Call<List<Productos?>?>?, response: Response<List<Productos?>?>) {
                    if (response.code() == 200) {
                        try {
                            for (pro in response.body()!!) {
                                val artiAcargar = Articles(
                                    pro?.sector,
                                    pro?.codigo,
                                    pro?.descripcion,
                                    pro?.codBar,
                                    pro?.codOrigen,
                                    pro?.precio,
                                    pro?.costo,
                                    pro?.exiVenta,
                                    pro?.exiDeposito,
                                    pro?.de,
                                    pro?.balanza,
                                    pro?.depSn,
                                    pro?.imagen
                                )
                                index += index
                                insertarProducto(artiAcargar)
                            }
                            countriesList.visibility = View.VISIBLE
                            countriesList.text = "¡Datos Importados Correctamente!"
                            loading_view.visibility = View.GONE
                        } catch (e: SocketTimeoutException) {
                            countriesList.visibility = View.VISIBLE
                            countriesList.text = "¡Sin conexión al Servidor!"
                            loading_view.visibility = View.GONE
                        }
                    } else if (response.code() == 404) {
                        countriesList.visibility = View.VISIBLE
                        countriesList.text = "¡Sin conexión al Servidor!"
                        loading_view.visibility = View.GONE
                    }
                }

                override fun onFailure(call: Call<List<Productos?>?>?, t: Throwable?) {                            countriesList.visibility = View.VISIBLE
                    countriesList.visibility = View.VISIBLE
                    countriesList.text = "¡Sin conexión al Servidor!"
                    loading_view.visibility = View.GONE
                }
            })
        } catch (e: RuntimeException) {
            countriesList.visibility = View.VISIBLE
            countriesList.text = "Error ${e.message}"
            loading_view.visibility = View.GONE
        }
        }
        SystemClock.sleep(2000);
        //activity?.onBackPressed()
//        val call = getInstance()
//            ?.createService(WebServiceApi::class.java)
//            ?.getProductos()
//        val api: WebService? = getInstance()!!.createService()
//        val call: Call<List<Productos>> = api!!.getProductos()

//        var index: Long = 1
//        call!!.enqueue(object : Callback<List<Productos>> {
//            override fun onResponse(call: Call<List<Productos>>, response: Response<List<Productos>>) {
//                if (response.code() == 200) {
//                    try {
//                        for (pro in response.body()!!) {
//                            val artiAcargar = Articles(
//                                pro.sector,
//                                pro.codigo,
//                                pro.descripcion,
//                                pro.codBar,
//                                pro.codOrigen,
//                                pro.precio,
//                                pro.costo,
//                                pro.exiVenta,
//                                pro.exiDeposito,
//                                pro.de,
//                                pro.balanza,
//                                pro.depSn,
//                                pro.imagen
//                            )
//                            index += index
//                            insertarProducto(artiAcargar)
//                        }
//                        countriesList.visibility = View.VISIBLE
//                        countriesList.text = "¡Datos Importados Correctamente!"
//                        loading_view.visibility = View.GONE
//                    } catch (e: SocketTimeoutException) {
//                        countriesList.visibility = View.VISIBLE
//                        countriesList.text = "¡Sin conexión al Servidor!"
//                        loading_view.visibility = View.GONE
//                    }
//                }
//            }
//
//            override fun onFailure(call: Call<List<Productos>>, t: Throwable) {
//                countriesList.visibility = View.VISIBLE
//                countriesList.text = (t.message + "." + t.cause)
//                loading_view.visibility = View.GONE
//            }
//        })

        //Este es el que andaba
//        var index: Long = 1
//        withContext(IO) {
//            val job = CoroutineScope(IO).launch {
//                // TODO: BORRO TODO LOS ARTICULOS DE LA BASE PARA CARGARLOS DE NUEVO
//                AppDb.getAppDb((activity as MainActivity))!!.ArticulosDAO()!!.deleteAllArticulos()
//                try {
//                    val response = WebServiceApi.
//                    if (response.isSuccessful) {
//
//                        for (pro in response.body()!!) {
//                            val artiAcargar = Articles(
//                                pro.sector,
//                                pro.codigo,
//                                pro.descripcion,
//                                pro.codBar,
//                                pro.codOrigen,
//                                pro.precio,
//                                pro.costo,
//                                pro.exiVenta,
//                                pro.exiDeposito,
//                                pro.de,
//                                pro.balanza,
//                                pro.depSn,
//                                pro.imagen
//                            )
//                            index += index
//                            AppDb.getAppDb((activity as MainActivity))!!.ArticulosDAO()!!.insertArticulos(artiAcargar)
//                        }
//                        withContext(Main) {
//                            countriesList.visibility = View.VISIBLE
//                            countriesList.text = "¡Datos Importados Correctamente!"
//                            loading_view.visibility = View.GONE
//                        }
//                    } else if (!response.isSuccessful) {
//                        withContext(Main) {
//                            countriesList.visibility = View.VISIBLE
//                            countriesList.text = "¡Sin servicio. No se puede conectar a la api o al servidor configurado en el BackEnd!"
//                            loading_view.visibility = View.GONE
//                        }
//                    }
//                } catch (e: SocketTimeoutException) {
//                    withContext(Main) {
//                        countriesList.visibility = View.VISIBLE
//                        countriesList.text = "¡Sin conexión al Servidor!"
//                        loading_view.visibility = View.GONE
//                    }
//                }
//            }
//        }
//       withContext(Dispatchers.Main) {
//            if (response.isSuccessful) {
//        val call = WebService
//            .instance
//            ?.createService(WebServiceApi::class.java)
//            ?.articulos
//        call?.enqueue(object : Callback<List<productos?>?> {
//            override fun onResponse(
//                call: Call<List<productos?>?>,
//                response: Response<List<productos?>?>
//            ) {
//                if (response.code() == 200) {
//                    for (i in response.body()!!.indices) {
//                        //AppDb.getAppDb((activity as MainActivity))!!.ArticulosDAO()?.insertArticulos(response.body()!![i])
//                        cargarArticulos(2, 500, "sfas", "66666","2,2", "2,2", false, false, "")
////                        Log.d(
////                            "TAG1", "Nombre Curso: " + response.body()!![i]?.sector
////                                    + "Codigo Profesor: " + response.body()!![i]?.descripcion
////                        )
//                        mostrarArticulos()
//                    }
//                } else if (response.code() == 404) {
//                    Log.d("TAG1", "No hay cursos")
//                }
//
//            }
//
//            override fun onFailure(call: Call<List<productos?>?>, t: Throwable) {}
//        })
    }

    fun insertarProducto(aCargar: Articles) {
        fragmentScopeAM.launch {
            withContext(IO) {
                AppDb.getAppDb((activity as MainActivity))!!.ArticulosDAO()!!.insertArticulos(aCargar)
            }
        }
    }

    fun mostrarArticulos() {
        fragmentScopeAM.launch {
            var listArticulos: List<Articles>? = null
            var temp: String = ""
            listArticulos = AppDb.getAppDb((activity as MainActivity))?.ArticulosDAO()?.findAllArticulos()
            if (listArticulos != null) {

                for (i in listArticulos.indices) temp += listArticulos[i].codigo.toString()
            }
            withContext(Main) {
                countriesList.visibility = View.VISIBLE
                loading_view.visibility = View.GONE
                countriesList?.text = temp
            }
        }
    }
}



