package com.focasoftware.deboinventariov20.UI.actualizacionMaestros

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.BaseViewHolder
import kotlinx.android.synthetic.main.item_inv_importados.view.*


class InvSecHeadListAdapter(
    private val context: Context, private val invHead: ArrayList<ItemsInvSecHead>, private val itemCheckListener: OnCheckListener
) : RecyclerView.Adapter<BaseViewHolder<*>>() {

    interface OnCheckListener {
        fun onItemCheck(inventario: String?)
    }

    override fun onCreateViewHolder(parent: ViewGroup, p1: Int) = ItemsViewHolder(LayoutInflater.from(context).inflate(R.layout.item_inv_importados, parent, false))

    override fun getItemCount() = invHead.size

    override fun onBindViewHolder(holder: BaseViewHolder<*>, position: Int) {
        when (holder) {
            is ItemsViewHolder -> {
                holder.bind(invHead[position], position)
            }
        }
    }

    inner class ItemsViewHolder(itemView: View) : BaseViewHolder<ItemsInvSecHead>(itemView) {
        override fun bind(item: ItemsInvSecHead, position: Int) {
            itemView.tvPrincipalinventario.setOnCheckedChangeListener { button, b -> itemCheckListener.onItemCheck(item.invnum.toString()) }
            itemView.tvPrincipalinventario.text = item.invnum.toString() + "-" + item.detalle.toString() + " " + item.fecha.toString()
        }
    }
}




