package com.focasoftware.deboinventariov20.UI.actualizacionMaestros

import android.app.AlertDialog
import android.content.DialogInterface
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.ProgressBar
import android.widget.TextView
import android.widget.Toast
import androidx.fragment.app.Fragment
import androidx.navigation.NavController
import androidx.navigation.Navigation
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.*
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.MainActivity
import com.focasoftware.deboinventariov20.UI.Utils.*

import kotlinx.android.synthetic.main.fragment_inv_importados.*
import kotlinx.coroutines.*
import kotlinx.coroutines.Dispatchers.IO
import kotlinx.coroutines.Dispatchers.Main
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.lang.Thread.sleep
import java.net.SocketTimeoutException

private lateinit var viewAdapter: RecyclerView.Adapter<*>
private lateinit var viewManager: RecyclerView.LayoutManager
private lateinit var recicler: RecyclerView
private var listInv = ArrayList<ItemsInvSecHead>()
private var serverPre: ServeInv? = null
var invSeleccionados = mutableListOf<String>()
private lateinit var navController: NavController

class InvSecImpFragment : Fragment(), InvSecHeadListAdapter.OnCheckListener {
    private val job: Job = Job()
    private val fragmentScopeInvSec = CoroutineScope(Dispatchers.IO + job)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        invSeleccionados.clear()
    }
    override fun onDestroy() {
        super.onDestroy()
        fragmentScopeInvSec.cancel()
    }
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val navController = Navigation.findNavController(view)
        val btnConfirmarAct = view.findViewById<Button>(R.id.btnConfirmarAct)
        val pbInvSec = view.findViewById<ProgressBar>(R.id.pbInvSec)
        val tvMensaje = view.findViewById<TextView>(R.id.tvMensaje)

        recicler = view.findViewById(R.id.rcDescripcion)

        fragmentScopeInvSec.launch(Main) {
            invSeleccionados.clear()
            pbInvSec.visibility = View.VISIBLE
            recicler.visibility = View.GONE
            try {
                serverPre = fetchServerPreOne(requireActivity())
            } catch (e: RuntimeException) {

                Toast.makeText(context, "Error ${e.message}", Toast.LENGTH_LONG).show()
            }
            if (serverPre != null) {
                if (serverPre!!.direccion.isNullOrEmpty()) {
                    val modalDialog = NoServerConf()
                    if (activity != null) {
                        modalDialog.show((activity as MainActivity).supportFragmentManager, "confirmDialog")
                    }
                } else {
                     BASE_URL = serverPre!!.direccion.toString() + ":" + serverPre!!.puertoSubida.toString() + "/"
                    listInv.clear()
                    try {
//                        val call: Call<List<InvHeadSecR?>?>? = WebService.instance
//                            ?.createService(WebServiceApi::class.java)
//                            ?.getHeadInvSec()
                        ItomInv.request.getHeadInvSec()
                            ?.enqueue(object : Callback<List<InvHeadSecR?>?> {
//                        call!!.enqueue(object : Callback<List<InvHeadSecR?>?> {
                            override fun onResponse(call: Call<List<InvHeadSecR?>?>?, response: Response<List<InvHeadSecR?>?>) {
                                if (response.code() == 200) {
                                    try {
                                        for (inv in response.body()!!) {
                                            cargarRecicler(inv?.invNum, inv!!.detalle, inv.fechaInicio, inv.depsn)
                                        }
                                    } catch (e: SocketTimeoutException) {
                                    }
                                } else if (response.code() == 404) {
                                    tvSeleccionInventario.visibility = View.VISIBLE
                                    tvMensaje.visibility = View.VISIBLE
                                    tvMensaje.text = "No hay inventarios disponibles."
                                    pbInvSec.visibility = View.GONE
                                }
                            }

                            override fun onFailure(call: Call<List<InvHeadSecR?>?>?, t: Throwable?) {}
                        })
                    } catch (e: RuntimeException) {
                        tvSeleccionInventario.visibility = View.VISIBLE
                        tvMensaje.visibility = View.VISIBLE
                        tvMensaje.text = "Error ${e.message}"
                        pbInvSec.visibility = View.GONE
                        tvMensaje.visibility = View.GONE
                    }
                    //                    obtenerInvSectorizados()
                }
            } else {
                if (activity != null) {
                    val modalDialog = ServerNoConf()
                    modalDialog.show((activity as MainActivity).supportFragmentManager, "confirmDialog")
                }
            }
            pbInvSec.visibility = View.GONE
            recicler.visibility = View.VISIBLE

        }


        btnConfirmarAct.setOnClickListener {
            var finalizo=false
            var contador=0

            for (inv in invSeleccionados) {

                GlobalScope.launch(Main) {
                    deleteAllInvHeadSec(inv.toInt())
                    deleteAllInvBodySec(inv.toInt())
                }
                val aEnviar: NumInvSec = NumInvSec(inv)
//                val call: Call<List<InvBodySecR?>?>? = WebService.instance
//                    ?.createService(WebServiceApi::class.java)
//                    ?.getBodyInvSec(aEnviar)
//                call!!.enqueue(object : Callback<List<InvBodySecR?>?> {
                ItomInv.request.getBodyInvSec(aEnviar)
                                   ?.enqueue(object : Callback<List<InvBodySecR?>?> {
                    override fun onResponse(call: Call<List<InvBodySecR?>?>?, response: Response<List<InvBodySecR?>?>) {

                        if (response.code() == 200) {
                            try {
                                if(preparaParaInsertar(response.body(), inv)) finalizo=true
//                                fragmentScopeInvSec.launch(Main) {
//                                         if (response.body() != null) {
//                                             for (head in listInv) {
//                                                 if (inv.toInt() == head.invnum) {
//                                                     val invHeadTemp = InvHeadSec(head.invnum, head.detalle, head.fecha, head.deposito == 1, "", head.fecha, 0)
//                                                     insertInvHeadSec(invHeadTemp)
//                                                     break
//                                                 }
//                                             }
//                                             for (body in response.body()!!) {
//                                                 val invBodyTemp = InvBodySec(
//                                                     body!!.INV.toInt(), body.SEC, body.ART, body.DET, body.PRE,
//                                                     body.uniVta,
//                                                     body.COS, "", body.DEPSN!!.toInt() != 0, body.EXIVTA, body.EXIDEP, body.CODBAR, "", ""
//                                                 )
//                                                 insertInvBodySec(invBodyTemp)
//                                             }
//                                         }
//                                    contador+=1
//                                    sleep(500)
//                                    buscarCantArtInvSecHead(inv)
//                                    sleep(500)
//                                    if(contador==invSeleccionados.size){
//                                        recicler.visibility = View.GONE
//                                                       btnConfirmarAct.isEnabled = false
//                                                       val modalDialog = InvSecImp()
//                                                       modalDialog.show(requireActivity().supportFragmentManager, "confirmDialog")
//
//                                                       activity?.onBackPressed()
//                                    }
//                                     }

                            } catch (e: SocketTimeoutException) {
                            }
                        } else if (response.code() == 404) { }
                    }
                    override fun onFailure(call: Call<List<InvBodySecR?>?>?, t: Throwable?) {}
                })
                finalizo=true
            }
            if (finalizo) {
                recicler.visibility = View.GONE
                btnConfirmarAct.isEnabled = false
                val modalDialog = InvSecImp()
                modalDialog.show(requireActivity().supportFragmentManager, "confirmDialog")

//                activity?.onBackPressed()

            }
//            navController.navigate(R.id.action_invSecImpFragment_to_mainFragment2)
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val v = inflater.inflate(R.layout.fragment_inv_importados, container, false)
        return v
    }

    private fun preparaParaInsertar(list: List<InvBodySecR?>?, inv: String):Boolean {

        fragmentScopeInvSec.launch(Main) {
            if (list != null) {
                for (head in listInv) {
                    if (inv.toInt() == head.invnum) {
                        val invHeadTemp = InvHeadSec(head.invnum, head.detalle, head.fecha, head.deposito == 1, "", head.fecha, 0)
                        insertInvHeadSec(invHeadTemp)
                        break
                    }
                }
                for (body in list) {
                    val invBodyTemp = InvBodySec(
                        body!!.INV.toInt(), body.SEC, body.ART, body.DET, body.PRE,
                        body.uniVta,
                        body.COS, "", body.DEPSN!!.toInt() != 0, body.EXIVTA, body.EXIDEP, body.CODBAR, "", ""
                    )
                    insertInvBodySec(invBodyTemp)
                }
            }
            sleep(500)
            buscarCantArtInvSecHead(inv)
            sleep(500)
        }
        return true
    }

    fun cargarRecicler(invNum: Int?, detalle: String?, fechaInicio: String?, deposito: Int?) {
        //TODO CARGO EN LE RV
        val item = ItemsInvSecHead(invNum, detalle, fechaInicio, deposito)
        listInv.add(item)

        viewAdapter = InvSecHeadListAdapter(requireContext(), listInv, this)
        viewManager = LinearLayoutManager(requireContext())
        //        deleteIcon = ContextCompat.getDrawable(requireContext(), R.drawable.borrar)!!
        recicler.apply {
            adapter = viewAdapter
            layoutManager = viewManager
        }
    }

    override fun onItemCheck(inventario: String?) {
        if (inventario in invSeleccionados) {
            invSeleccionados.removeIf { it == inventario }
        } else {
            fragmentScopeInvSec.launch(Main) {
                var invBodySec: List<InvBodySec>? = null
                invBodySec = verificoExisteInvSec(inventario!!.toInt())
                if (!invBodySec.isNullOrEmpty()) {
                    AlertDialog.Builder(requireContext()).setTitle("El inventario $inventario ya se encuentra cargado.").setMessage(" Si continúa se perderan los datos ingresados.")
                        .setPositiveButton(R.string.btnOk, DialogInterface.OnClickListener { dialog, which ->
                            invSeleccionados.add(inventario)
                        }).setNegativeButton(R.string.btnCancelar, DialogInterface.OnClickListener { dialog, which ->

                        }).show()
                } else invSeleccionados.add(inventario)
            }
        }
    }

    private suspend fun insertInvBodySec(inventario: InvBodySec) {
        return withContext(fragmentScopeInvSec.coroutineContext + IO) {
            AppDb.getAppDb(requireActivity())!!.InvBodySecDAO()!!.insertInvBodySec(inventario)
        }
    }

    private suspend fun insertInvHeadSec(inventario: InvHeadSec) {
        return withContext(fragmentScopeInvSec.coroutineContext + IO) {
            AppDb.getAppDb(requireActivity())!!.InvHeadSecDAO()!!.insertInvHeadSec(inventario)
        }
    }

    private suspend fun deleteAllInvHeadSec(invNum: Int) {
        return withContext(fragmentScopeInvSec.coroutineContext + IO) {
            AppDb.getAppDb(requireContext())!!.InvHeadSecDAO()!!.deleteAllInvHeadSec(invNum)
        }
    }

    private suspend fun deleteAllInvBodySec(invNum: Int) {
        return withContext(fragmentScopeInvSec.coroutineContext + IO) {
            AppDb.getAppDb(requireContext())!!.InvBodySecDAO()!!.deleteAllInvBodySec(invNum)
        }
    }

    private suspend fun buscarCantArtInvSecHead(invNum: String) {
        return withContext(fragmentScopeInvSec.coroutineContext + IO) {
            val arti = mutableListOf<String>()
            val invBodySec: List<InvBodySec> = fetchInvSecBodyGroup(invNum)
//            var cant = 0
//            var encontrado: Boolean
//            var first = false
//            for (inv in invBodySec) {
//                if (!first) {
//                    arti.add(inv.sector.toString() + inv.codigo.toString())
//                    first = true
//                    cant += 1
//                } else {
//                    encontrado = false
//                    for (ar in arti) {
//
//                        +
//                        if (ar == inv.sector.toString() + inv.codigo.toString()) {
//                            encontrado = true
//                            break
//                        }
//                    }
//                    if (!encontrado) {
//                        cant += 1
//                        arti.add(inv.sector.toString() + inv.codigo.toString())
//                    }
//                }
//            }
            AppDb.getAppDb(requireActivity())!!.InvHeadSecDAO()!!.updateCantArtInvSecHead(invNum.toInt(), invBodySec.count())
        }
    }

    private suspend fun verificoExisteInvSec(invNum: Int): List<InvBodySec> {
        var busqueda: List<InvBodySec>
        return fragmentScopeInvSec.async(IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvBodySecDAO()!!.verificoExisteInvSec(invNum)
            return@async busqueda
        }.await()
    }

    private suspend fun fetchInvSecBodyGroup(invNum: String): List<InvBodySec> {
        var busqueda: List<InvBodySec>
        return fragmentScopeInvSec.async(IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvBodySecDAO()!!.fetchInvSecBodyGroup(invNum)
            return@async busqueda
        }.await()
    }
}