package com.focasoftware.deboinventariov20.UI.descripCorigenFragment

import android.app.AlertDialog
import android.content.Context
import android.content.SharedPreferences
import android.graphics.Canvas
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.text.Editable
import android.text.InputType
import android.text.TextWatcher
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.view.inputmethod.InputMethodManager
import androidx.fragment.app.FragmentActivity
import androidx.lifecycle.lifecycleScope
import androidx.navigation.NavController
import androidx.navigation.Navigation
import androidx.recyclerview.widget.ItemTouchHelper
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.Articles
import com.focasoftware.deboinventariov20.Model.InvBody
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.obtenerFechaActual
import com.focasoftware.deboinventariov20.UI.Utils.modificarCantidadEnCabecera
import kotlinx.android.synthetic.main.ingresar_cantidad.view.*
import kotlinx.android.synthetic.main.ingresar_cantidad.view.btnAceptar
import kotlinx.android.synthetic.main.login_dialog.view.*
import kotlinx.coroutines.*

//
class CodigoOriFragment : Fragment() {

    private lateinit var artAcargar2: List<Articles>
    private var listArticulos: List<Articles>? = null
    lateinit var viewAdapter2: RecyclerView.Adapter<*>
    private lateinit var viewManager2: RecyclerView.LayoutManager
    private lateinit var rcCodigoOri: RecyclerView
    private var swipeBackground: ColorDrawable = ColorDrawable(Color.YELLOW)
    private var cantidad = 0F
    private var numeroInventario = 0
    lateinit var navController: NavController
    lateinit var sharedPreferences: SharedPreferences
    private var artCargadoEnBD: InvBody? = null
    lateinit var mDialogViewM: View
    var resultadoTemp:Float=0F

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        sharedPreferences = requireActivity().getSharedPreferences("SP_INFO", Context.MODE_PRIVATE)
        arguments.apply {
            artAcargar2 = requireArguments().getSerializable("ArrayDesc") as List<Articles>
            numeroInventario = requireArguments().getInt("numeroInv")
        }

    }
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        navController = Navigation.findNavController(view)
        showSoftKeyboard(view)
    }
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val v = inflater.inflate(R.layout.fragment_codigo_ori, container, false)
        rcCodigoOri = v.findViewById(R.id.rcCodigoOri)

        IngresarRecicler(artAcargar2)
        showSoftKeyboard(v)
//        btnSalir.setOnClickListener {
//            activity?.onBackPressed();
////            VolverAinventario()
//        }
        return v
    }

    private fun showSoftKeyboard(view: View) {
        if (view.requestFocus()) {
            val imm = requireActivity().getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            imm.showSoftInput(view, InputMethodManager.HIDE_IMPLICIT_ONLY)
        }
    }

    fun IngresarRecicler(articulos: List<Articles>) {

        viewAdapter2 = CodigoOrigenAdapter(requireContext(),articulos)
        viewManager2 = LinearLayoutManager(requireContext())

        rcCodigoOri.apply {
            adapter = viewAdapter2
            layoutManager = viewManager2
        }
        val itemTouchHelperCallback = object : ItemTouchHelper.SimpleCallback(0, ItemTouchHelper.LEFT) {
            override fun onMove(p0: RecyclerView, p1: RecyclerView.ViewHolder, target: RecyclerView.ViewHolder): Boolean {
                return false
            }

            override fun onSwiped(viewHolder: RecyclerView.ViewHolder, position: Int) {

                GlobalScope.launch(Dispatchers.Main) {
                    //TODO BUSCO EN BASE DE DATOS
                    artCargadoEnBD = buscarCodigoDeboEnBD((viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)?.sector.toString(),
                        (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)?.codigo.toString(),
                        numeroInventario.toString())
                    if (artCargadoEnBD == null) {
                        val mDialogView = LayoutInflater.from(context).inflate(R.layout.ingresar_cantidad, null)
                        val mBuilder = AlertDialog.Builder(context).setView(mDialogView).setCancelable(false)
                        //TODO: DEPENDIENDO DEL TIPO DE ARTICULO PERMITER INGRESAR DECIMALES O NO
                        if ((viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.balanza==1 || (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.balanza==3 || (viewAdapter2 as CodigoOrigenAdapter).items2?.get(
                                viewHolder.layoutPosition)!!.balanza==7)
                            mDialogView.etCantidad.inputType= InputType.TYPE_CLASS_NUMBER

                        mDialogView.tvTitulo.text = "${(viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.descripcion}"
                        val mAlertDialog = mBuilder.show()
                        mDialogView.etCantidad.requestFocus()
                        mAlertDialog.window!!.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE or WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
                        mAlertDialog.window!!.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_VISIBLE)
                        mDialogView.btnAceptar.setOnClickListener {
                            if (mDialogView.etCantidad.text.isNullOrEmpty()) {
                                mDialogView.etCantidad.error = "No vacio"
                                mDialogView.etCantidad.requestFocus()
                                mDialogView.etCantidad.hint = "Ingrese un valor"
                            } else if (!mDialogView.etCantidad.text.isNullOrEmpty()) {
                                cantidad = mDialogView.etCantidad.text.toString().toFloat()
                                val body = InvBody(numeroInventario,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.sector,
                                    // TODO: PREPARO PARA MANDAR A CARGAR EN LA BD
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.codigo,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.descripcion,
                                    cantidad.toString(),
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.codBar,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.codOrigen,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.precio,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.precio,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.balanza,
                                    (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.depSn,
                                    obtenerFechaActual(),
                                    obtenerFechaActual())
                                InsertarArtEnDB(body)// TODO: MANDO A CARGAR A LA BASE DE DATOS
                                modificarCantidadEnCabecera(numeroInventario, true, requireActivity())
//                                VolverAinventario()
                                activity?.onBackPressed()
                                mAlertDialog.dismiss()
                            }
                        }
                    } else if (artCargadoEnBD != null) {

                        mDialogViewM = LayoutInflater.from(context).inflate(R.layout.login_dialog, null)
                        val mBuilder = AlertDialog.Builder(context).setView(mDialogViewM).setCancelable(false)
                        if (artCargadoEnBD!!.balanza.toString().contains("1") || artCargadoEnBD!!.balanza.toString().contains("3") || artCargadoEnBD!!.balanza.toString().contains("7")) mDialogViewM.tvNuevaCantidad.inputType= InputType.TYPE_CLASS_NUMBER
                        mDialogViewM.tvTitulo2.text="${artCargadoEnBD!!.descripcion}"
                        mDialogViewM.tvCantInicial.text = (Math.round(artCargadoEnBD!!.cantTomada.toString().toFloat() * 100.0) / 100.0).toString()


                        val mAlertDialog = mBuilder.show()
                        mDialogViewM.tvNuevaCantidad.requestFocus()
                        mDialogViewM.tvNuevaCantidad.addTextChangedListener(textWatcher)

                        mAlertDialog?.window!!.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE or WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
                        mAlertDialog.window!!.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_VISIBLE)

                        mDialogViewM.rbSumar.setOnClickListener {
                            if (!mDialogViewM.tvNuevaCantidad.text.isNullOrEmpty()) {
                                resultadoTemp=mDialogViewM.tvCantInicial.text.toString().toFloat() + mDialogViewM.tvNuevaCantidad.text.toString().toFloat()
                                mDialogViewM.tvResultado.text = (Math.round(resultadoTemp * 100.0) / 100.0).toString()
                            }
                        }
                        mDialogViewM.rbRestar.setOnClickListener {
                            if (!mDialogViewM.tvNuevaCantidad.text.isNullOrEmpty()) {
                                if (mDialogViewM.tvCantInicial.text.toString().toFloat() >= mDialogViewM.tvNuevaCantidad.text.toString().toFloat()) {
                                    resultadoTemp= mDialogViewM.tvCantInicial.text.toString().toFloat() - mDialogViewM.tvNuevaCantidad.text.toString().toFloat()
                                    mDialogViewM.tvResultado.text =  (Math.round(resultadoTemp * 100.0) / 100.0).toString()
                                }else{
                                    mDialogViewM.tvResultado.text=""
                                    mDialogViewM.tvResultado.error = "Operación No Valida"
                                    mDialogViewM.tvResultado.requestFocus()
                                    mDialogViewM.tvResultado.hint = "Error"
                                }
                            }
                        }
                        mDialogViewM.rbMdodificar.setOnClickListener {
                            if (!mDialogViewM.tvNuevaCantidad.text.isNullOrEmpty()) {
                                mDialogViewM.tvResultado.text = (Math.round(mDialogViewM.tvNuevaCantidad.text.toString().toFloat() * 100.0) / 100.0).toString()
                            }
                        }
                        mDialogViewM.btnAceptar.setOnClickListener {
                            if (mDialogViewM.tvNuevaCantidad.text.isNotEmpty() || !mDialogViewM.tvNuevaCantidad.text.isBlank()) {
                                if (mDialogViewM.tvResultado.text.isNotEmpty() || !mDialogViewM.tvResultado.text.isBlank()) {

                                    updateCantidad((viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.sector.toString(),
                                        (viewAdapter2 as CodigoOrigenAdapter).items2?.get(viewHolder.layoutPosition)!!.codigo.toString(),
                                        mDialogViewM.tvResultado.text.toString().toFloat())
//                                VolverAinventario()
                                    activity?.onBackPressed();
                                    mAlertDialog.dismiss()
                                } else if (mDialogViewM.tvNuevaCantidad.text.isNotEmpty() || mDialogViewM.tvNuevaCantidad.text.isBlank()) {
                                    mDialogViewM.tvResultado.error = "Operación Requerida"
                                    mDialogViewM.tvResultado.requestFocus()
                                    mDialogViewM.tvResultado.hint = "Seleccione Operación"
                                }
                            } else if (mDialogViewM.tvNuevaCantidad.text.isEmpty() || mDialogViewM.tvNuevaCantidad.text.isBlank()) {
                                mDialogViewM.tvNuevaCantidad.error = "Completar"
                                mDialogViewM.tvNuevaCantidad.requestFocus()
                                mDialogViewM.tvNuevaCantidad.hint = "Ingrese un valor"
                            }
                        }
                        mDialogViewM.dialogCancelBtn.setOnClickListener {
                            activity?.onBackPressed();
                            mAlertDialog.dismiss()
                        }
                    }
                }
            }

            override fun onChildDraw(c: Canvas, recyclerView: RecyclerView, viewHolder: RecyclerView.ViewHolder, dX: Float, dY: Float, actionState: Int, isCurrentlyActive: Boolean) {
                super.onChildDraw(c, recyclerView, viewHolder, dX, dY, actionState, isCurrentlyActive)
                val itemView = viewHolder.itemView

                c.clipRect(0f, itemView.top.toFloat(), dX, itemView.bottom.toFloat())

                if (dX > 0) {

                    c.drawColor(Color.RED)
                } else if (dX < 0) {
                    // swipeBackground.setBounds(itemView.right+dX.toInt(),itemView.top,itemView.right,itemView.bottom)
                    c.drawColor(Color.YELLOW)
                }
                swipeBackground.draw(c)
                super.onChildDraw(c, recyclerView, viewHolder, dX, dY, actionState, isCurrentlyActive)
            }
        }
        val itemTouchHelper2 = ItemTouchHelper(itemTouchHelperCallback)
        itemTouchHelper2.attachToRecyclerView(rcCodigoOri)

    }

    fun InsertarArtEnDB(cuarpoInventario: InvBody) {
        lifecycleScope.launch {
            withContext(Dispatchers.IO) {
                AppDb.getAppDb(requireActivity())!!.InvBodyDAO()!!.insertInvBody(cuarpoInventario)
            }
        }
    }

    suspend fun buscarCodigoDeboEnBD(sector: String, codigo: String, numInventario: String): InvBody? {
        //TODO BUSQUEDA POR CODIGO DE BARRAS
        var busqueda: InvBody? = null
        return GlobalScope.async(Dispatchers.IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvBodyDAO()!!.fetchArtInInvBody(sector.toLong(), codigo.toLong(), numInventario.toInt())
            return@async busqueda
        }.await()
    }

    fun updateCantidad(sector: String, codigo: String, cantidad: Float) {
        lifecycleScope.launch {
            withContext(Dispatchers.IO) {
                val activity: FragmentActivity? = activity
                if (activity != null && isAdded) {
                    AppDb.getAppDb(requireActivity())!!.InvBodyDAO()!!.updateInvBody(cantidad, sector.toLong(), codigo.toLong(), obtenerFechaActual())
                }
            }
        }
    }
    private val textWatcher = object : TextWatcher {
        override fun afterTextChanged(s: Editable?) {
            if (mDialogViewM.tvNuevaCantidad.text.toString() == "") { mDialogViewM.tvResultado.text = ""}
        }

        override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
        }

        override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            if (mDialogViewM.tvNuevaCantidad.text.toString() != "") {

                if (mDialogViewM.rbSumar.isChecked) {
                    resultadoTemp = mDialogViewM.tvNuevaCantidad.text.toString().toFloat() + mDialogViewM.tvCantInicial.text.toString().toFloat()
                    mDialogViewM.tvResultado.text = (Math.round(resultadoTemp * 100.0) / 100.0).toString()
                }
                if (mDialogViewM.rbRestar.isChecked) {
                    if (!mDialogViewM.tvNuevaCantidad.text.isNullOrEmpty()) {
                        if (mDialogViewM.tvCantInicial.text.toString().toFloat() >= mDialogViewM.tvNuevaCantidad.text.toString().toFloat()) {
                            resultadoTemp = mDialogViewM.tvCantInicial.text.toString().toFloat() - mDialogViewM.tvNuevaCantidad.text.toString().toFloat()
                            mDialogViewM.tvResultado.text = (Math.round(resultadoTemp * 100.0) / 100.0).toString()
//                              mDialogView.tvNuevaCantidad.isEnabled = false
                        } else {
                            mDialogViewM.tvResultado.text = ""
                            mDialogViewM.tvResultado.error = "Operación No Valida"
                            mDialogViewM.tvResultado.requestFocus()
                            mDialogViewM.tvResultado.hint = "Error"
                        }
                    }
                }
                if (mDialogViewM.rbMdodificar.isChecked) {
                    if (!mDialogViewM.tvNuevaCantidad.text.isNullOrEmpty()) {
                        mDialogViewM.tvResultado.text = (Math.round(mDialogViewM.tvNuevaCantidad.text.toString().toFloat() * 100.0) / 100.0).toString()
//                          mDialogView.tvNuevaCantidad.isEnabled = false
                    }
                }
            }
        }
    }
}