package com.focasoftware.deboinventariov20.UI.detalleProducto

import android.content.Context
import android.content.SharedPreferences
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.inputmethod.InputMethodManager
import androidx.fragment.app.Fragment
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.Articles
import com.focasoftware.deboinventariov20.R
import kotlinx.android.synthetic.main.fragment_detalle_art.*
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.Dispatchers.Main
import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.async
import kotlinx.coroutines.launch

class DetalleArtFragment : Fragment() {

    private var Inventario: Int = 0
    private var sector: String? = null
    private var codigo: String? = null
    private var artSerch: Articles? = null
    lateinit var sharedPreferences: SharedPreferences

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        sharedPreferences = requireActivity().getSharedPreferences("SP_INFO", Context.MODE_PRIVATE)
        arguments?.let {
            sector = it.getString("sector")
            codigo = it.getString("codigo")
            Inventario= it.getInt("numeroInv")
        }
        val imm = requireActivity().getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager?
        imm!!.hideSoftInputFromWindow(requireActivity().currentFocus?.windowToken, InputMethodManager.HIDE_NOT_ALWAYS)

        marcarInventario()
        GlobalScope.launch(Main) {
            artSerch = buscarCodigoDeboEnBD(sector, codigo)
            if (artSerch == null) {

//                                val type = InputType.TYPE_CLASS_NUMBER
//                                MaterialDialog(requireContext()).show {
//
//                                    title(text = "Producto '$sChangeUpper', se encuentra cargado.")
//                                    message(R.string.sCantidadNueva)
//                                    input(waitForPositiveButton = false, hint = "99.99", inputType = type) { materialDialog, charSequence ->
//                                        fCant = 0F
//                                        fCant = charSequence.toString().toFloat()
//                                    }
//                                    positiveButton(R.string.btnOk) {
//                                        //TODO ACTUALIZO CANTIADAD EN BD
//                                        updateCantidad(listArticulos[indiceDelArtEncontrado].sector.toString(), listArticulos[indiceDelArtEncontrado].codigo.toString(), fCant)
//                                        //TODO ACTUALIZO CANTIDAD EN RV
//                                        listArticulos[indiceDelArtEncontrado].cantTomada = fCant
//                                        viewAdapter.notifyDataSetChanged()
//                                        dismiss()
//                                    }
//                                }.cancelOnTouchOutside(false).cornerRadius(10F)
            } else if (artSerch != null) {
                tvSector.text=sector
                tvCodigo.text=codigo
                tvDeposito.text=if(!artSerch!!.depSn!!)"No" else "Si"
                tvDescripcion.text=artSerch!!.descripcion.toString()
                tvCodigoBarras.text=if (artSerch!!.codBar.toString()=="null")"" else artSerch!!.codBar.toString()
                tvCodigoOrigen.text=if (artSerch!!.codOrigen.toString()=="null")"" else artSerch!!.codOrigen.toString()
                tvExiVenta.text=artSerch!!.exiVenta.toString()
                tvExiDeposito.text=artSerch!!.exiDeposito.toString()

                when ( artSerch!!.balanza.toString().toInt()) {
                    1 ->tvBal.text="Unidades"
                    2 ->tvBal.text="Litros"
                    3 ->tvBal.text="Cajas"
                    4 ->tvBal.text="M3"
                    5 ->tvBal.text="Metros"
                    6 ->tvBal.text="Fracción"
                    7 ->tvBal.text="Bultos"
                    8 ->tvBal.text="Gramos"
                    9 ->tvBal.text="Cent. cúbicos"
                    10 ->tvBal.text="Kgs"
                    else -> { tvBal.text="Otros"
                    }
                }
                if(artSerch!!.costo!=null)
                    tvCosto.text= (Math.round(artSerch!!.costo.toString().toFloat() * 100.0) / 100.0).toString()
                else tvCosto.text="0"

                if(artSerch!!.precio!=null )
                    tvPrecio.text= (Math.round( artSerch!!.precio.toString().toFloat() * 100.0) / 100.0).toString()
                else tvPrecio.text="0"
            }
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {

        return inflater.inflate(R.layout.fragment_detalle_art, container, false)
    }

    suspend fun buscarCodigoDeboEnBD(sector: String?, codigo: String?): Articles? {
        //TODO BUSQUEDA POR CODIGO DE BARRAS
        var busqueda: Articles?
        return GlobalScope.async(Dispatchers.IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.ArticulosDAO()!!.fetchArticuloByCodSec(sector, codigo)
            return@async busqueda
        }.await()
    }
    fun marcarInventario() {

        val editor = sharedPreferences.edit()
        editor?.putString("Inventario", Inventario.toString())
        editor?.apply()
        editor.commit()
//        navController.navigate(R.id.action_descripcionFragment_to_inventarioFragment)
    }
}