package com.focasoftware.deboinventariov20.UI.detalleProducto

import android.content.Context
import android.content.SharedPreferences
import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.inputmethod.InputMethodManager
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.Articles
import com.focasoftware.deboinventariov20.Model.InvBodySec
import com.focasoftware.deboinventariov20.R
import kotlinx.android.synthetic.main.fragment_detalle_art.*
import kotlinx.android.synthetic.main.fragment_inv_sec.*
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.async
import kotlinx.coroutines.launch

private lateinit var sharedPreferences: SharedPreferences
private var Inventario: String? = null
private var sector: String? = null
private var codigo: String? = null
private var busqueda: String? = null
private var artSerch: InvBodySec? = null

class DetalleArtSecFragment : Fragment() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        sharedPreferences = requireActivity().getSharedPreferences("SP_INFO", Context.MODE_PRIVATE)

         arguments?.let {
             sector = it.getString("sector")
             codigo = it.getString("codigo")
             busqueda= it.getString("Busqueda")
             Inventario= it.getString("numeroInv").toString()
         }
         val imm = requireActivity().getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager?
         imm!!.hideSoftInputFromWindow(requireActivity().currentFocus?.windowToken, InputMethodManager.HIDE_NOT_ALWAYS)

         GlobalScope.launch(Dispatchers.Main) {
             artSerch = Inventario?.let { buscarCodigoDeboEnBD(it,sector, codigo) }
             if (artSerch != null) {
                 tvSector.text=sector
                 tvCodigo.text=codigo
                 tvDeposito.text=if(!artSerch!!.depSn!!)"No" else "Si"
                 tvDescripcion.text=artSerch!!.descripcion.toString()
                 tvCodigoBarras.text=if (artSerch!!.CODBAR.toString()=="null")"" else artSerch!!.CODBAR.toString()
//                 tvCodigoOrigen.text=if (artSerch!!.codOrigen.toString()=="null")"" else artSerch!!.codOrigen.toString()
                 tvExiVenta.text=artSerch!!.EXIVTA.toString()
                 tvExiDeposito.text=artSerch!!.EXIDEP.toString()

                 when ( artSerch!!.uniVenta.toString().toInt()) {
                     1 ->tvBal.text="Unidades"
                     2 ->tvBal.text="Litros"
                     3 ->tvBal.text="Cajas"
                     4 ->tvBal.text="M3"
                     5 ->tvBal.text="Metros"
                     6 ->tvBal.text="Fracción"
                     7 ->tvBal.text="Bultos"
                     8 ->tvBal.text="Gramos"
                     9 ->tvBal.text="Cent. cúbicos"
                     10 ->tvBal.text="Kgs"
                     else -> { tvBal.text="Otros"
                     }
                 }
                 tvCosto.text= (Math.round(artSerch!!.costo.toString().toFloat() * 100.0) / 100.0).toString()
                 tvPrecio.text=(Math.round(artSerch!!.precio.toString().toFloat() * 100.0) / 100.0).toString()
             }
         }
        val editor = sharedPreferences.edit()
            editor?.putString("BusquedaVuelta", busqueda)
            editor?.apply()
            editor.commit()
    }
    suspend fun buscarCodigoDeboEnBD(inventario: String, sector: String?, codigo: String?): InvBodySec? {
        //TODO BUSQUEDA POR CODIGO DE BARRAS
        var busqueda: InvBodySec?
        return GlobalScope.async(Dispatchers.IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvBodySecDAO()!!.fetchArticuloByCodSec(inventario,sector!!, codigo!!)
            return@async busqueda
        }.await()
    }
    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {return inflater.inflate(R.layout.fragment_detalle_art_sec, container, false) }

}