package com.focasoftware.deboinventariov20.UI.inventario

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Filter
import android.widget.Filterable
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.BaseViewHolder
import kotlinx.android.synthetic.main.item.view.*
import java.util.*
import kotlin.collections.ArrayList

class ProdSecListAdapter(private val context: Context, private var productos: ArrayList<ItemsSecRecycler>, private val itemImageClickListener: InvSecFragment) :
    RecyclerView.Adapter<BaseViewHolder<*>>() {

    interface OnImageDotsClickListener {
        fun onImagePenClick(numInv: String?, sector: String?, codigo: String?, cantidad: String?, position: String)
        fun onImageDotsClick(numInv: String?, sector: String?, codigo: String?)
    }

    override fun onCreateViewHolder(parent: ViewGroup, p1: Int) = ItemsViewHolder(LayoutInflater.from(context).inflate(R.layout.item, parent, false))

    override fun getItemCount(): Int {
        return productos.count()
    }

    override fun onBindViewHolder(holder: BaseViewHolder<*>, position: Int) {
        when (holder) {
            is ItemsViewHolder -> {
                holder.bind(productos[position], position)
            }
        }
    }

    inner class ItemsViewHolder(itemView: View) : BaseViewHolder<ItemsSecRecycler>(itemView) {
        override fun bind(item: ItemsSecRecycler, position: Int) {

            itemView.ivDots.setOnClickListener { itemImageClickListener.onImageDotsClick(item.invNum, item.sector, item.codigo) }
            itemView.ivPen.setOnClickListener { itemImageClickListener.onImagePenClick(item.invNum, item.sector, item.codigo, item.contado, adapterPosition.toString()) }
            itemView.tvDescripcion.text = item.descripcion
            itemView.tvCantidad.text = item.contado
            itemView.ivPen.setImageResource(R.drawable.pen)
            itemView.ivDots.setImageResource(R.drawable.more)
        }
    }
}