package com.focasoftware.deboinventariov20.UI.inventario

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.BaseViewHolder
import kotlinx.android.synthetic.main.item.view.*


class ProductosListAdapter(private val context: Context, private val productos: ArrayList<ItemsRecycler>, private val itemImageClickListener: OnImageDotsClickListener) :
    RecyclerView.Adapter<BaseViewHolder<*>>() {

    private var removePosition: Int = 0
    private var removedItem: ItemsRecycler? = null

    interface OnImageDotsClickListener {
        fun onImageDotsClick(sector: String?,codigo: String?)
        fun onImagePenClick(sector: String?, codigo: String?, cantidad: String?, position: String)

    }

    override fun onCreateViewHolder(parent: ViewGroup, p1: Int) = ItemsViewHolder(LayoutInflater.from(context).inflate(R.layout.item, parent, false))

    override fun getItemCount() = productos.size

    override fun onBindViewHolder(holder: BaseViewHolder<*>, position: Int) {
        when (holder) {
            is ItemsViewHolder -> { holder.bind(productos[position], position) }

        }
    }
    inner class ItemsViewHolder (itemView: View)  : BaseViewHolder<ItemsRecycler>(itemView) {
        override fun bind(item: ItemsRecycler, position: Int) {
            itemView.ivDots.setOnClickListener {itemImageClickListener.onImageDotsClick(item.sector,item.codigo)  }
            itemView.ivPen.setOnClickListener {itemImageClickListener.onImagePenClick(item.sector,item.codigo,item.cantTomada.toString(),adapterPosition.toString())  }

            itemView.tvDescripcion.text=item.descripcion
            itemView.tvCantidad.text=item.cantTomada.toString()
            itemView.ivPen.setImageResource(R.drawable.pen)
            itemView.ivDots.setImageResource(R.drawable.more)
        }
    }

    fun removeItem(viewHolder: RecyclerView.ViewHolder) {
        removePosition = viewHolder.adapterPosition
        removedItem = productos[viewHolder.adapterPosition]

        productos.removeAt(viewHolder.adapterPosition)
        notifyItemRemoved(viewHolder.adapterPosition)
    }
}

