package com.focasoftware.deboinventariov20.UI.main

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Filter
import android.widget.Filterable
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.Model.InvHead
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.BaseViewHolder
import kotlinx.android.synthetic.main.item_principal.view.*
import java.util.*
import kotlin.collections.ArrayList

class InventarioListAdapter(private val context: Context, private val inv: List<InvHead>, private val itemClickListener: OnInventarioClickListener) :
    RecyclerView.Adapter<BaseViewHolder<*>>() {

    interface OnInventarioClickListener {
        fun onItemClick(inventario: String?)
    }

    override fun onCreateViewHolder(parent: ViewGroup, p1: Int) = ItemsViewHolder(LayoutInflater.from(context).inflate(R.layout.item_principal, parent, false))

    override fun getItemCount() = inv.size


    inner class ItemsViewHolder(itemView: View) : BaseViewHolder<InvHead>(itemView) {
        override fun bind(item: InvHead, position: Int) {
            itemView.setOnClickListener {itemClickListener.onItemClick(item.invNum.toString())}
            itemView.tvPrincipalinventario.text = if ( item.invNum < 10) "#0${ item.invNum.toString()}" else  "#"+item.invNum.toString()

            itemView.tvDescription.text=item.descripcion.toString()
            itemView.tvFecha.text=item.fechaInicio.toString()
            itemView.tvCantContada.text=item.prodContados.toString()
        }
    }

    override fun onBindViewHolder(holder: BaseViewHolder<*>, position: Int) {
        when (holder) {
            is ItemsViewHolder -> holder.bind(inv[position], position)
            else -> IllegalArgumentException("No se pudo pasar el ViewHolder")
        }
    }
}