package com.focasoftware.deboinventariov20.UI.main

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.Model.InvHeadSec
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.Utils.BaseViewHolder
import kotlinx.android.synthetic.main.item_principal.view.*

class InventarioSecListAdapter(private val context: Context, private val inv: List<InvHeadSec>, private val itemClickListener: MainFragment) :
    RecyclerView.Adapter<BaseViewHolder<*>>() {

    interface OnInventarioSecClickListener {
        fun onItemSecClick(inventario: String?, nombre: String?)
    }

    override fun onCreateViewHolder(parent: ViewGroup, p1: Int) = ItemsViewHolder(LayoutInflater.from(context).inflate(R.layout.item_principal, parent, false))

    override fun getItemCount() = inv.size

    inner class ItemsViewHolder(itemView: View) : BaseViewHolder<InvHeadSec>(itemView) {
        override fun bind(item: InvHeadSec, position: Int) {
            itemView.setOnClickListener { itemClickListener.onItemSecClick(item.invNum.toString(), item.detalle.toString()) }
            itemView.tvPrincipalinventario.text = if (item.invNum < 10) "#0${item.invNum}" else "#" + item.invNum.toString()

            itemView.tvDescription.text = item.detalle.toString()
            itemView.tvFecha.text = item.fechaInicio.toString()
            //SimpleDateFormat("dd/MM/yyyy HH:mm:SS").format(DateFormat(hd)).toString()
            itemView.tvCantContada.text = item.prodContados.toString()
        }
    }

    override fun onBindViewHolder(holder: BaseViewHolder<*>, position: Int) {
        when (holder) {
            is ItemsViewHolder -> holder.bind(inv[position], position)
            else -> IllegalArgumentException("No se pudo pasar el ViewHolder")
        }
    }
}