package com.focasoftware.deboinventariov20.UI.main

import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.content.SharedPreferences
import android.os.Bundle
import android.provider.Settings
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.view.inputmethod.InputMethodManager
import android.widget.CheckBox
import android.widget.ImageButton
import android.widget.ImageView
import android.widget.TextView
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentActivity
import androidx.navigation.NavController
import androidx.navigation.Navigation
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.focasoftware.deboinventariov20.DB.DataBase.AppDb
import com.focasoftware.deboinventariov20.Model.*
import com.focasoftware.deboinventariov20.R
import com.focasoftware.deboinventariov20.UI.MainActivity
import com.focasoftware.deboinventariov20.UI.Utils.*
import kotlinx.android.synthetic.main.fragment_main.*
import kotlinx.android.synthetic.main.solicitar_fecha.view.*
import kotlinx.coroutines.*
import kotlinx.coroutines.Dispatchers.Main
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.net.SocketTimeoutException
import java.util.*
import kotlin.math.absoluteValue

class MainFragment : Fragment(), InventarioListAdapter.OnInventarioClickListener, InventarioSecListAdapter.OnInventarioSecClickListener {
    private var inventarios: List<InvHead>? = null
    private var inventariosII: List<InvHeadSec>? = null
    private lateinit var ordenado: List<InvHead>
    private lateinit var ordenadoII: List<InvHeadSec>
    private lateinit var rcInventario: RecyclerView
    private lateinit var rcInventarioII: RecyclerView
    private lateinit var viewAdapter: RecyclerView.Adapter<*>
    private lateinit var viewManager: RecyclerView.LayoutManager
    private var listIvn2 = ArrayList<InvHead>()
    private var listIvn2II = ArrayList<InvHeadSec>()
    private lateinit var navController: NavController
    private lateinit var sharedPreferences: SharedPreferences
    private var cantidadInventarios: Int = 0
    private var cantidadInventariosII: Int = 0
    private val job: Job = Job()
    private val fragmentScopeMain = CoroutineScope(Dispatchers.IO + job)
    private var serverBajada: ServeInv? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        sharedPreferences = (activity as MainActivity).getSharedPreferences("SP_INFO", Context.MODE_PRIVATE)

        if (sharedPreferences.contains("inicio")) {
            if (sharedPreferences.getString("inicio", "").toString() == "inicio") {
                if (sharedPreferences.contains("cbAskTimeServerToStart")) {
                    if (sharedPreferences.getString("cbAskTimeServerToStart", "").toString() == "1") {
                        GlobalScope.launch(Main) {
                            serverBajada = AppDb.getAppDb((activity as MainActivity))!!.ServeInvDao()!!.fetchServerPreOne()
                            if (serverBajada != null) {
                                if (serverBajada!!.direccion.isNullOrEmpty()) {
                                    val modalDialog = NoServerConf()
                                    modalDialog.show((activity as MainActivity).supportFragmentManager, "confirmDialog")
                                } else {
                                    BASE_URL = serverBajada!!.direccion.toString() + ":" + serverBajada!!.puertoBajada.toString() + "/"
                                }
                            }

                            val call: Call<List<Time?>?>? = WebService.instance
                                ?.createService(WebServiceApi::class.java)
                                ?.getTime()
                            call!!.enqueue(object : Callback<List<Time?>?> {
                                override fun onResponse(call: Call<List<Time?>?>?, response: Response<List<Time?>?>) {
                                    if (response.code() == 200) {
                                        try {
                                            val timeServer =
                                                response.body()?.get(0)?.dia + "/" +
                                                        response.body()?.get(0)?.mes + "/" +
                                                        response.body()?.get(0)?.ano + " " +
                                                        response.body()?.get(0)?.hora + ":" +
                                                        response.body()?.get(0)?.minutos + ":" +
                                                        response.body()?.get(0)?.segundos
                                            val horaServer = response.body()?.get(0)?.hora + "" +
                                                    response.body()?.get(0)?.minutos + "" +
                                                    response.body()?.get(0)?.segundos
                                            val fechaServer = response.body()?.get(0)?.dia + "" +
                                                    response.body()?.get(0)?.mes + "" +
                                                    response.body()?.get(0)?.ano
                                            if (!askTimeServer(timeServer, horaServer, fechaServer)) {
                                            }
                                        } catch (e: SocketTimeoutException) {
                                        }
                                    } else if (response.code() == 400) {
                                    }
                                }

                                override fun onFailure(call: Call<List<Time?>?>?, t: Throwable?) {}
                            })
                        }
                        val editor = sharedPreferences.edit()
                        editor?.putString("inicio", "")
                        editor?.apply()
                        editor.commit()
                    }
                }
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        fragmentScopeMain.cancel()
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        var bAbiertoCerrado = false
        var bAbiertoCerradoII = false
        val v = inflater.inflate(R.layout.fragment_main, container, false)
        val tvInvDinamicos = v.findViewById<TextView>(R.id.tvInvDinamicos)
        val tvInvImportados = v.findViewById<TextView>(R.id.tvInvImportados)
        val ivSort19 = v.findViewById<ImageButton>(R.id.ivSort19)
        val ivSort91 = v.findViewById<ImageButton>(R.id.ivSort91)
        val ivSort19II = v.findViewById<ImageButton>(R.id.ivSort19II)
        val ivSort91II = v.findViewById<ImageButton>(R.id.ivSort91II)
        val cbVentas = v.findViewById<CheckBox>(R.id.cbVentas)
        val cbDeposito = v.findViewById<CheckBox>(R.id.cbDeposito)
        val tvTipo = v.findViewById<TextView>(R.id.tvTipo)
        val ivPortada = v.findViewById<ImageView>(R.id.ivPortada)
        rcInventario = v.findViewById(R.id.rcInventario)
        rcInventarioII = v.findViewById(R.id.rcInventarioII)
        ivPortada.visibility = View.VISIBLE

        fragmentScopeMain.launch(Main) {






            inventarios = buscarEnBDInvHead()
            for ((i, item) in inventarios!!.withIndex()) {
                val inv = InvHead(
                    inventarios!![i].invNum,
                    inventarios!![i].descripcion,
                    inventarios!![i].estado,
                    inventarios!![i].fechaInicio,
                    inventarios!![i].fechaFinal,
                    inventarios!![i].prodContados,
                    inventarios!![i].lugar,
                    inventarios!![i].stDesc,
                    inventarios!![i].proNoCont
                )
                cargarRecicler(inv)
                cantidadInventarios = i + 1
            }
            tvInvDinamicos.text = "Inventarios Dinámicos ($cantidadInventarios) +"
            listIvn2II.clear()
            inventariosII = buscarEnBDInvSecHead()
            for ((i, item) in inventariosII!!.withIndex()) {
                val invII = InvHeadSec(
                    inventariosII!![i].invNum,
                    inventariosII!![i].detalle,
                    inventariosII!![i].fechaInicio,
                    inventariosII!![i].depsn,
                    inventariosII!![i].estado,
                    inventariosII!![i].fechaFinal,
                    inventariosII!![i].prodContados
                )
                cargarReciclerII(invII)
                cantidadInventariosII = i + 1
            }
            tvInvImportados.text = "Inventarios Importados ($cantidadInventariosII) +"

            tvInvDinamicos.setOnClickListener {
                if (!bAbiertoCerrado) {
                    bAbiertoCerrado = true
                    tvInvImportados.visibility = View.GONE
                    ivSort91II.visibility = View.GONE
                    ivSort19II.visibility = View.GONE
                    rcInventario.visibility = View.VISIBLE
                    ivSort91.visibility = View.INVISIBLE
                    ivSort19.visibility = View.VISIBLE
                    cbVentas.visibility = View.VISIBLE
                    cbDeposito.visibility = View.VISIBLE
                    tvTipo.visibility = View.VISIBLE
                    ivPortada.visibility = View.GONE
                    tvInvDinamicos.text = "Inventarios Dinamicos ($cantidadInventarios) -"
                } else {
                    bAbiertoCerrado = false
                    rcInventario.visibility = View.GONE
                    ivSort91.visibility = View.GONE
                    ivSort19.visibility = View.GONE
                    tvInvImportados.visibility = View.VISIBLE
                    cbVentas.visibility = View.GONE
                    cbDeposito.visibility = View.GONE
                    tvTipo.visibility = View.GONE
                    ivPortada.visibility = View.VISIBLE
                    tvInvDinamicos.text = "Inventarios Dinamicos ($cantidadInventarios) +"
                }
            }

            ordenado = inventarios!!.sortedBy { it.invNum }

            ivSort19.setOnClickListener {
                ordenado = inventarios!!.sortedByDescending {
                    it.invNum
                }
                cbDeposito.isChecked = true
                cbVentas.isChecked = true
                viewAdapter = InventarioListAdapter(requireContext(), ordenado, this@MainFragment)
                viewManager = LinearLayoutManager(requireContext())

                rcInventario.apply {
                    adapter = viewAdapter
                    layoutManager = viewManager
                }
                viewAdapter.notifyDataSetChanged()
                ivSort19.visibility = View.INVISIBLE
                ivSort91.visibility = View.VISIBLE
            }

            ivSort91.setOnClickListener {
                ordenado = inventarios!!.sortedBy {
                    it.invNum
                }
                cbDeposito.isChecked = true
                cbVentas.isChecked = true
                viewAdapter = InventarioListAdapter(requireContext(), ordenado, this@MainFragment)
                viewManager = LinearLayoutManager(requireContext())

                rcInventario.apply {
                    adapter = viewAdapter
                    layoutManager = viewManager
                }
                viewAdapter.notifyDataSetChanged()
                ivSort91.visibility = View.INVISIBLE
                ivSort19.visibility = View.VISIBLE
            }

            tvInvImportados.setOnClickListener {
                if (!bAbiertoCerradoII) {
                    bAbiertoCerradoII = true
                    tvInvDinamicos.visibility = View.GONE
                    ivSort19.visibility = View.GONE
                    ivSort91.visibility = View.GONE
                    cbVentas.visibility = View.GONE
                    cbDeposito.visibility = View.GONE
                    ivPortada.visibility = View.GONE
                    tvInvDinamicos.visibility = View.GONE
                    rcInventarioII.visibility = View.VISIBLE
                    rcInventario.visibility = View.GONE
                    ivSort91II.visibility = View.INVISIBLE
                    ivSort19II.visibility = View.VISIBLE
                    tvInvImportados.text = "Inventarios Importados ($cantidadInventariosII) -"
                } else {
                    bAbiertoCerradoII = false
                    ivPortada.visibility = View.VISIBLE
                    rcInventarioII.visibility = View.GONE
                    ivSort91II.visibility = View.GONE
                    ivSort19II.visibility = View.GONE
                    tvInvImportados.visibility = View.VISIBLE
                    tvInvDinamicos.visibility = View.VISIBLE
                    tvInvImportados.text = "Inventarios Importados ($cantidadInventariosII) +"
                }
            }
            ordenadoII = inventariosII!!.sortedBy { it.invNum }

                       ivSort19II.setOnClickListener {
                           ordenadoII = inventariosII!!.sortedByDescending {
                               it.invNum
                           }
                           viewAdapter = InventarioSecListAdapter(requireContext(), ordenadoII, this@MainFragment)
                           viewManager = LinearLayoutManager(requireContext())

                           rcInventarioII.apply {
                               adapter = viewAdapter
                               layoutManager = viewManager
                           }
                           viewAdapter.notifyDataSetChanged()
                           ivSort19II.visibility = View.INVISIBLE
                           ivSort91II.visibility = View.VISIBLE
                       }

                       ivSort91II.setOnClickListener {
                           ordenadoII = inventariosII!!.sortedBy {
                               it.invNum
                           }
                           viewAdapter = InventarioSecListAdapter(requireContext(), ordenadoII, this@MainFragment)
                           viewManager = LinearLayoutManager(requireContext())

                           rcInventarioII.apply {
                               adapter = viewAdapter
                               layoutManager = viewManager
                           }
                           viewAdapter.notifyDataSetChanged()
                           ivSort91II.visibility = View.INVISIBLE
                           ivSort19II.visibility = View.VISIBLE
                       }

        }

        cbVentas.setOnClickListener {
            if (!cbVentas.isChecked) {
                cbDeposito.isChecked = true
                listIvn2.clear()
                ordenado.forEach {
                    if (it.lugar == true) {
                        listIvn2.add(it)
                    }
                }
            } else {
                listIvn2.clear()
                listIvn2.addAll(ordenado)
            }
            viewAdapter = InventarioListAdapter(requireContext(), listIvn2, this@MainFragment)
            viewManager = LinearLayoutManager(requireContext())
            rcInventario.apply {
                adapter = viewAdapter
                layoutManager = viewManager
            }
            viewAdapter.notifyDataSetChanged()
        }

        cbDeposito.setOnClickListener {
            if (!cbDeposito.isChecked) {
                cbVentas.isChecked = true
                listIvn2.clear()
                ordenado.forEach {
                    if (it.lugar == false) {
                        listIvn2.add(it)
                    }
                }
            } else {
                listIvn2.clear()
                listIvn2.addAll(ordenado)
            }
            viewAdapter = InventarioListAdapter(requireContext(), listIvn2, this@MainFragment)
            viewManager = LinearLayoutManager(requireContext())
            rcInventario.apply {
                adapter = viewAdapter
                layoutManager = viewManager
            }
            viewAdapter.notifyDataSetChanged()
        }

        return v
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        navController = Navigation.findNavController(view)
        listIvn2.clear()
        listIvn2II.clear()
        ivPortada.visibility = View.VISIBLE
    }

    fun cargarRecicler(inv: InvHead) {
        //TODO CARGO EN LE RV

        listIvn2.add(inv)
        viewAdapter = InventarioListAdapter(requireContext(), listIvn2, this)
        viewManager = LinearLayoutManager(requireContext())

        rcInventario.apply {
            adapter = viewAdapter
            layoutManager = viewManager
        }
    }

    fun cargarReciclerII(inv: InvHeadSec) {
        //TODO CARGO EN LE RV

        listIvn2II.add(inv)
        viewAdapter = InventarioSecListAdapter(requireContext(), listIvn2II, this)
        viewManager = LinearLayoutManager(requireContext())

        rcInventarioII.apply {
            adapter = viewAdapter
            layoutManager = viewManager
        }
    }

    override fun onItemClick(inventario: String?) {
        val editor = sharedPreferences.edit()
        editor?.putString("Inventario", inventario)
        editor?.apply()
        editor.commit()
        navController.navigate(R.id.action_mainFragment2_to_inventarioFragment)
    }

    override fun onItemSecClick(inventario: String?, nombre: String?) {
        val editor = sharedPreferences.edit()
        editor?.putString("InventarioSecNum", inventario)
        editor?.putString("InventarioSecNom", nombre)
        editor?.apply()
        editor.commit()
        navController.navigate(R.id.action_mainFragment2_to_invSecFragment)
    }

    private suspend fun buscarEnBDInvHead(): List<InvHead> {
        //TODO BUSQUEDA POR DESCRIPCION
        var busqueda: List<InvHead>
        return fragmentScopeMain.async(Dispatchers.IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvHeadDAO()!!.fetchAllInvHead()
            return@async busqueda
        }.await()
    }

    private suspend fun buscarEnBDInvSecHead(): List<InvHeadSec> {
        //TODO BUSQUEDA POR DESCRIPCION
        var busqueda: List<InvHeadSec>
        return fragmentScopeMain.async(Dispatchers.IO) {
            busqueda = AppDb.getAppDb(requireContext())!!.InvHeadSecDAO()!!.fetchAllInvSecHead()
            return@async busqueda
        }.await()
    }


private suspend fun fetchServerPreOne(): ServeInv? {
    return fragmentScopeMain.async(Dispatchers.IO) {
        return@async  AppDb.getAppDb(requireContext())!!.ServeInvDao()!!.fetchServerPreOne()
    }.await()
}


    private fun askTimeServer(timeServer: String, horaServer: String, fechaServer: String): Boolean {

        var existeDiferencias = false
        val horaAct = obtenerHoraActual().toDouble()
        val fechaAct = obtenerDiaActual().toDouble()
        val difFecha = fechaAct - fechaServer.toDouble()
        val difHora = horaAct - horaServer.toDouble()
        if (difFecha.absoluteValue > 0) existeDiferencias = true
        if (difHora.absoluteValue > 130) existeDiferencias = true

        if (existeDiferencias) {
            dialogoHoraServer((activity as MainActivity), requireContext(), obtenerFechaActual(), timeServer)
        }

        return existeDiferencias
    }

//private fun dialogoHoraServerLocal(reqActivity: FragmentActivity, context: Context, fechaHoraDispositivo: String, fechaHoraServer: String) {
//    val mDialogView: View = LayoutInflater.from(context).inflate(R.layout.solicitar_fecha, null)
//    val mBuilder = AlertDialog.Builder(context).setView(mDialogView).setCancelable(false)
//
//    mDialogView.tvHoraDispositivo.text = fechaHoraDispositivo
//    mDialogView.tvHoraServidor.text = fechaHoraServer
//    val mAlertDialog = mBuilder.show()
//    val imm = reqActivity.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager?
//    imm!!.hideSoftInputFromWindow(reqActivity.currentFocus?.windowToken, InputMethodManager.HIDE_IMPLICIT_ONLY )
//
////    mAlertDialog?.window!!.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE or WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
////    mAlertDialog.window!!.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_VISIBLE)
//
//
//    mDialogView.btnCambiarHora.setOnClickListener {
//        context.startActivity(Intent(Settings.ACTION_DATE_SETTINGS))
//        mAlertDialog.dismiss()
//    }
//
//    mDialogView.btnSalir.setOnClickListener {
//        mAlertDialog.dismiss()
//    }
//}
}

